﻿<AML>
 <Item type="Method" id="C49467989D194FE496B2D40E9EDFB518" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			calculate_sub_amount
            Created By/Company:		MyoThet 
            Creation Date:			2018-08-28
            Description:
                Calculation Sub Amount when saving.

            Hooks:
                Type:		Server Events : sop_sale_order
                Event:		OnAfterUpdate
                Called by:	<Parent functions>

            Inputs:
                <describe the inputs expected by the server method>

            Revisions:
                Rev Date		Modified By			Description
                YYYY-MM-DD		***					Initial creation
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "calculate_sub_amount";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                decimal f_sub_total = 0;
                var total_price = "";
                string id = this.getID();
                string pop_lumpsum_discount = this.getProperty("pop_lumpsum_discount", "0");
                decimal f_discount = Convert.ToDecimal(pop_lumpsum_discount);
                string pop_gst_percent = this.getProperty("pop_gst_percent", "0");
                decimal f_gst_percent = Convert.ToDecimal(pop_gst_percent) / 100;
                decimal total_line_2 = Convert.ToDecimal(this.getProperty("sop_total_line_2_value", "0"));
                decimal total_line_3 = Convert.ToDecimal(this.getProperty("sop_total_line_3_value", "0"));
                decimal total_line_4 = Convert.ToDecimal(this.getProperty("sop_total_line_4_value", "0"));
                decimal total_line_5 = Convert.ToDecimal(this.getProperty("sop_total_line_5_value", "0"));
                decimal total_line_6 = Convert.ToDecimal(this.getProperty("sop_total_line_6_value", "0"));

                Item sop_sale_order_details = myInnovator.getItemById("sop_sale_order", id);
                var get_so_details_relationship = sop_sale_order_details.fetchRelationships("sop_sale_order_details");
                get_so_details_relationship = sop_sale_order_details.getRelationships("sop_sale_order_details");
                var so_details_count = get_so_details_relationship.getItemCount();
                for (var i = 0; i < get_so_details_relationship.getItemCount(); i++)
                {
                    Item get_so_details_index = get_so_details_relationship.getItemByIndex(i);
                    var get_section_relationship = get_so_details_index.fetchRelationships("sop_section_details");
                    get_section_relationship = get_so_details_index.getRelationships("sop_section_details");
                    var section_details_count = get_section_relationship.getItemCount();
                    for (var j = 0; j < get_section_relationship.getItemCount(); j++)
                    {
                        var get_section_relationship_index = get_section_relationship.getItemByIndex(j);
                        total_price = get_section_relationship_index.getProperty("stk_total_amount", "0");
                        f_sub_total += Convert.ToDecimal(total_price);
                    }
                    total_price = get_so_details_index.getProperty("stk_total_amount", "0");
                    f_sub_total += Convert.ToDecimal(total_price);
                }
                f_sub_total = f_sub_total + total_line_2 + total_line_3 + total_line_4 + total_line_5 + total_line_6;
                f_sub_total = f_sub_total - f_discount;
                decimal gst_amount = (f_sub_total * f_gst_percent);
                decimal total_amount = (f_sub_total + gst_amount);

                StringBuilder sb_update_so = new StringBuilder("");
                sb_update_so.Append("UPDATE innovator.sop_sale_order");
                sb_update_so.Append(" SET pop_sub_amount = '" + f_sub_total.ToString() + "'");
                sb_update_so.Append(" , pop_gst_amount = '" + gst_amount.ToString() + "'");
                sb_update_so.Append(" , pop_total_amount = '" + total_amount.ToString() + "'");
                sb_update_so.Append(" WHERE id = '" + id + "'");
                string str_update_so = sb_update_so.ToString();
                Item update_so = myInnovator.applySQL(str_update_so);
                if (update_so.isError())
                {
                    return myInnovator.newResult("error : " + update_so.getErrorDetail());
                }

            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>calculate_sub_amount</name>
 </Item>
</AML>